#include <iostream>
#include <vector>
#include <cstdint>
#include <map>
#include <set>
#include <random>
#include <cassert>
 
using namespace std;
using ll = long long;
using ld = double;
using ull = unsigned long long;
 
#define pbc push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define vin(a) \
  for (auto& i : a) cin >> i
 
// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(228);
 
template <typename T1, typename T2>
inline void chkmin(T1& x, const T2& y) {
  if (y < x) {
    x = y;
  }
}
 
template <typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
  if (x < y) {
    x = y;
  }
}
 
const ll INF = 1e18;
const int MINL = -1e9 - 10, MAXR = 1e9 + 10;
  
struct Line {
  ld k, b;
  Line() : k(0), b(INF) {
  }
  Line(ld x, ld y) : k(x), b(y) {
  }
};
  
ld eval(Line l, int x) {
  return l.k * x + l.b;
}
  
struct Node {
  Line l = Line();
  Node *L = nullptr, *R = nullptr;
  Node() = default;
  Node(Line x) : l(x), L(nullptr), R(nullptr) {
  }
};
  
struct LiChao {
  Node *root;
  LiChao() {
    root = new Node();
  }
  
  Node* add(Line x, Node *root, int tl, int tr) {
    if (root == nullptr) root = new Node();
    int tm = (tl + tr) / 2;
    bool mid = eval(x, tm) < eval(root->l, tm);
    bool left = eval(x, tl) < eval(root->l, tl);
    if (mid) swap(x, root->l);
    if (tl == tr - 1) return root;
    if (mid != left) {
      root->L = add(x, root->L, tl, tm);
    } else {
      root->R = add(x, root->R, tm, tr);
    }
    return root;
  }
  
  // vector<Line> lines;
 
  void add(Line x) {
    root = add(x, root, MINL, MAXR);
    // lines.push_back(x);
  }
  
  ld get(int x, Node *root, int tl, int tr) {
    if (root == nullptr) return INF;
    if (tl >= x + 1 || tr <= x) return INF;
    if (tl == tr - 1) return eval(root->l, x);
    int tm = (tl + tr) / 2;
    return min(eval(root->l, x), min(get(x, root->L, tl, tm),
                get(x, root->R, tm, tr)));
  }
  
  ld get(int x) {
    return get(x, root, MINL, MAXR);
    // ld ans = INF;
    // for (auto l : lines) {
    //   chkmin(ans, eval(l, x));
    // }
    // return ans;
  }
};
 
signed main() {
  cin.tie(0)->sync_with_stdio(0);
  cout.precision(20), cout.setf(ios::fixed);
  int n, m, c;
  cin >> n >> m >> c;
  vector<int> x(n + 5);
  vector<int> t(n + 5);
  for (int i = 0; i < n; ++i) {
    cin >> x[i] >> t[i];
  }
  x[n] = m;
  vector<ld> dp(n + 5);
  dp[0] = 0;
  LiChao st;
  st.add(Line(0, 0));
  for (int i = 1; i <= n + 1; ++i) {
    dp[i] = st.get(x[i - 1]) + (ld)x[i-1] * x[i-1] / c;
    st.add(Line((ld)-2 * x[i - 1] / c, dp[i] + t[i - 1] + (ld)x[i - 1] * x[i - 1] / c));
  }
  cout << dp[n + 1] << endl;
  return 0;
}