#include <bits/stdc++.h>

using namespace std;

using ll = long long;
mt19937 rng(566);

void solveTest() {
  int n, m, k;
  cin >> n >> m >> k;
  vector<int> p(n);
  for (int& x : p) {
    cin >> x;
    --x;
  }
  vector<int> posP(n);
  for (int i = 0; i < n; ++i) {
    posP[p[i]] = i;
  }
  vector<int> a(m);
  for (int& x : a) {
    cin >> x;
    --x;
    if (x >= 0) {
      x = posP[x];
    }
  }

  int const INF = int(1e9);
  vector<int> minEnd(m, INF);
  for (int i = 0; i < m; ++i) {
    if (a[i] == 0) {
      int j = i;
      while (j < m && a[j] == j - i) {
        ++j;
      }
      if (j - i == n) {
        minEnd[i] = j;
      }
    }
  }
  for (int i = m - 2; i >= 0; --i) {
    minEnd[i] = min(minEnd[i], minEnd[i + 1]);
  }
  vector<int> lenMatch(m);
  for (int i = m - 1; i >= 0; --i) {
    if (a[i] < 0) {
      lenMatch[i] = 0;
    } else {
      lenMatch[i] = 1;
      if (i + 1 < m && a[i + 1] == a[i] + 1) {
        lenMatch[i] += lenMatch[i + 1];
      }
    }
  }
  vector<int> lenMatchLeft(m);
  for (int i = 0; i < m; ++i) {
    if (a[i] < 0) {
      lenMatchLeft[i] = 0;
    } else {
      lenMatchLeft[i] = 1;
      if (i - 1 >= 0 && a[i - 1] == a[i] - 1 && a[i - 1] >= 0) {
        lenMatchLeft[i] += lenMatchLeft[i - 1];
      }
    }
  }

  struct edge {
    int to;
    int id;
  };
  vector<vector<edge>> graph(n + 1);
  auto addEdge = [&](int from, int to, int id) {
    graph[from].push_back({to, id});
  };
  vector<pair<int, int>> ranges(k);
  for (auto& [l, r] : ranges) {
    cin >> l >> r;
    --l;
  }
  for (int it = 0; it < k; ++it) {
    auto[l, r] = ranges[it];
    if (minEnd[l] <= r) {
      cout << 1 << "\n";
      cout << it + 1 << "\n";
      return;
    }

    //  check substring
    int len = r - l;
    assert(len > 0);
    if (lenMatch[l] >= len) {
      addEdge(a[l], a[r - 1] + 1, it);
      continue;
    }
      
    //  check suffix  
    if (a[l] >= 0 && lenMatch[l] >= n - a[l]) {
      addEdge(a[l], n, it);
    }
    
    //  check prefix
    if (a[r - 1] >= 0 && lenMatchLeft[r - 1] > a[r - 1]) {
      addEdge(0, a[r - 1] + 1, it);
    }
  }
  vector<int> dp(n + 1, INF);
  dp[n] = 0;
  for (int u = n - 1; u >= 0; --u) {
    for (auto[v, i] : graph[u]) {
      dp[u] = min(dp[u], dp[v] + 1);
    }
  }

  for (int iter = 0; iter < 5; ++iter) {
    vector<int> path;
    int cur = 0;
    while (cur < n) {
      shuffle(graph[cur].begin(), graph[cur].end(), rng);
      for (auto[v, i] : graph[cur]) {
        if (dp[v] + 1 == dp[cur]) {
          path.push_back(i);
          cur = v;
          break;
        }
      }
    }
    if (set<int>(path.begin(), path.end()).size() == path.size()) {
      cout << path.size() << "\n";
      for (int x : path) {
        cout << x + 1 << " ";
      }
      cout << "\n";
      return;
    }
  }
  cout << -1 << "\n";
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int t; cin >> t;
  while (t--) solveTest();

  
  return 0;
}
