#include <bits/stdc++.h>

using ll = long double;
using ld = long double;
using namespace std;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &i: a)out << i << ' ';
    return out;
}

struct pt {
    ld x;
    ld y;

    pt(ld x = {}, ld y = {}) : x(x), y(y) {}

    pt operator-(const pt &other) const {
        return {x - other.x, y - other.y};
    }

    pt operator+(const pt &other) const {
        return {x + other.x, y + other.y};
    }

    pt operator*(ld a) const {
        return {x * a, y * a};
    }
};

struct circle {
    pt p;
    ld r;

    circle(pt p = {}, ld r = {}) : p(p), r(r) {}
};

struct line {
    ld a;
    ld b;
    ld c;

    line(ld a = {}, ld b = {}, ld c = {}) : a(a), b(b), c(c) {}
};

ld dist(ll x1, ll y1, ll x2, ll y2) {
    return sqrt((y1 - y2) * (y1 - y2) + (x1 - x2) * (x1 - x2));
}

pt intersect(line ln, circle c) {
    if (ln.a == 0) {
        ld y = -ln.c / ln.b;
        ld x = sqrt(c.r * c.r - y * y);
        return {x, y};
    }
    if (ln.b == 0) {
        ld x = -ln.c / ln.a;
        ld y = sqrt(c.r * c.r - x * x);
        return {x, y};
    }
    ld d = ln.b * ln.b * ln.c * ln.c / ln.a / ln.a / ln.a / ln.a;
    d -= (ln.a * ln.a + ln.b * ln.b) / ln.a / ln.a * (ln.c * ln.c / ln.a / ln.a - c.r * c.r);
    ld y = (-ln.b * ln.c / ln.a / ln.a + sqrt(d)) / ((ln.a * ln.a + ln.b * ln.b) / ln.a / ln.a);
    ld x = (-ln.b * y - ln.c) / ln.a;
    return {x, y};
}

pt intersect2(circle c1, circle c2) {
    return intersect(line(-2 * c2.p.x, -2 * c2.p.y, c2.p.x * c2.p.x + c2.p.y * c2.p.y + c1.r * c1.r - c2.r * c2.r), c1);
}

pt intersect(circle c1, circle c2) {
    return intersect2({{0, 0}, c1.r}, {c2.p - c1.p, c2.r}) + c1.p;
}

void slave() {
    ll x0, y0, x1, y1;
    cin >> x0 >> y0 >> x1 >> y1;
    ll n;
    cin >> n;
    vector<ll> v(n);
    cin >> v;
    ll d1 = dist(x0, y0, x1, y1);
    v.push_back(d1);
    ll mx = 0;
    ll ss = 0;
    ll ind = 0;
    for (int i = 0; i <= n; i++) {
        mx = max(mx, v[i]);
        if (mx == v[i])ind = i;
        ss += v[i];
    }
    if (2 * mx > ss) {
        cout << "Impossible\n";
        return;
    }
    cout << "Possible\n";
    ll r1 = 0;
    if (ind == n) {
        r1 = v[0];
    } else {
        r1 = mx;
    }
    ll r2 = ss - d1 - r1;
    //cout << r1 << " " << r2 << "\n";
    pt p = intersect(circle({x0, y0}, r1), circle({x1, y1}, r2));
    //cout<<dist(p.x, p.y, x0, y0)<<" "<<dist(p.x, p.y, x1, y1)<<"\n";
    if (ind == n) {
        cout << p.x << " " << p.y << "\n";
        for (int i = 1; i < n; i++) {
            pt p1 = p + (pt(x1, y1) - p) * (v[i] / dist(p.x, p.y, x1, y1));
            cout << p1.x << " " << p1.y << "\n";
        }
    } else {
        vector<pt> v1;
        for (int i = 0; i < n; i++) {
            if (ind == i) {
                v1.push_back(p - pt(x0, y0));
            } else {
                v1.push_back((pt(x1, y1) - p) * (v[i] / dist(p.x, p.y, x1, y1)));
            }
        }
        pt p1 = (x0, y0);
        for (int i = 0; i < n; i++) {
            p1 = p1 + v1[i];
            cout << p1.x << " " << p1.y << "\n";
        }
    }
}

signed main() {
    cout << fixed << setprecision(17);
#ifdef _GLIBCXX_DEBUG
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#endif
    int AnnaSamsonovaGoSex = 1;
    //cin>>AnnaSamsonovaGoSex;
    while (AnnaSamsonovaGoSex--)slave();
}
