#include <algorithm>
#include <chrono>
#include <cmath>
#include <iostream>
#include <random>
#include <set>
#include <string>
#include <vector>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;

    vector<pair<int, int>> v(n);

    for (int i = 0; i < n; i++) {
        cin >> v[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> v[i].second;
    }

    sort(v.begin(), v.end());

    int cnt = 0;

    const int CNT = 10000;

    while (cnt <= CNT) {
        bool bad = false;
        int j = -1;
        for (int i = 1; i < n; i++) {
            // i-1
            if (v[i - 1].second > v[i].second) {
                swap(v[i - 1].second, v[i - 1].first);
                bad = true;
                j = i - 1;
                break;
            }
        }
        cnt++;

        if (!bad) {
            break;
        }

        while (j + 1 < n && v[j] > v[j + 1]) {
            swap(v[j], v[j + 1]);
            j++;
        }

        while (j - 1 >= 0 && v[j] < v[j - 1]) {
            swap(v[j], v[j - 1]);
            j++;
        }
    }

    if (cnt >= CNT) {
        cout << "-1";
        return 0;
    }

    for (auto p: v) {
        cout << p.first << ' ';
    }
    cout << '\n';
    for (auto p: v) {
        cout << p.second << ' ';
    }
}
