#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;
template<typename T>
using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


const ld eps = 1e-4;

ld dist(ld x, ld y) {
    return sqrtl(x * x + y * y);
}

ld sqdist(ld x, ld y) {
    return x * x + y * y;
}

pair<ld, ld> normalize(ld x, ld y) {
    ld d = dist(x, y);
    if (d <= eps) return {x, y};
    return {x / d, y / d};
}

pair<ld, ld> intersect(ld r1, ld x, ld y, ld r2) {
    if (fabs(dist(x, y)) <= eps) return {0, r1};
//    if (abs(dist(x, y) - r1) > r2) assert(false);
    ld l = dist(x, y);
    ld cs = (r1 * r1 + l * l - r2 * r2) / (2.0 * r1 * l);
    ld sn = sqrtl(1.0 - cs * cs);
    ld d = cs * r1, h = sn * r1;
    return {normalize(x, y).first * d + normalize(y, -x).first * h,
            normalize(x, y).second * d + normalize(y, -x).second * h};
}

void solve() {
    ld x0, y0, x1, y1;
    cin >> x0 >> y0 >> x1 >> y1;
    int n;
    cin >> n;
    vector<int> v(n);
    for (int& x : v) cin >> x;

    x1 -= x0, y1 -= y0;

    vector<ld> r1(n), r2(n);
    r1[0] = r2[0] = v[0];
    for (int i = 1; i < n; i++) {
        if (r1[i - 1] <= v[i] && v[i] <= r2[i - 1]) {
            r1[i] = 0;
        } else {
            r1[i] = min(abs(r1[i - 1] - v[i]), abs(r2[i - 1] - v[i]));
        }
        r2[i] = r2[i - 1] + v[i];
    }

    if (!(r1.back() <= dist(x1, y1) + eps && dist(x1, y1) <= r2.back() + eps)) {
        cout << "Impossible";
        return;
    }

    vector<pair<ld, ld>> ans(n);
    ans.back() = {x1, y1};
    for (int i = n - 2; i >= 0; i--) {
        if (abs(v[i + 1] - r1[i]) <= dist(ans[i + 1].first, ans[i + 1].second) && dist(ans[i + 1].first, ans[i + 1].second) <= v[i + 1] + r1[i]) {
            ans[i] = intersect(r1[i], ans[i + 1].first, ans[i + 1].second, v[i + 1]);
        } else if (abs(v[i + 1] - r2[i]) <= dist(ans[i + 1].first, ans[i + 1].second) && dist(ans[i + 1].first, ans[i + 1].second) <= v[i + 1] + r2[i]) {
            ans[i] = intersect(r2[i], ans[i + 1].first, ans[i + 1].second, v[i + 1]);
        } else {
            ld d = dist(ans[i + 1].first, ans[i + 1].second) - v[i + 1];
            ans[i] = {normalize(ans[i + 1].first, ans[i + 1].second).first * d,
                      normalize(ans[i + 1].first, ans[i + 1].second).second * d};
        }
//        ld d = sqdist(ans[i + 1].first, ans[i + 1].second);
////        cout << i + 1 << ": " << d << ", " << (v[i + 1] - r2[i]) * (v[i + 1] - r2[i]) << " " << (v[i + 1] + r2[i]) * (v[i + 1] + r2[i]) << "\n";
//        if ((v[i + 1] - r1[i]) * (v[i + 1] - r1[i]) <= d + eps && d <= (v[i + 1] + r1[i]) * (v[i + 1] + r1[i]) + eps) {
////            cout << i + 1 << ": in\n";
//            ans[i] = intersect(r1[i], ans[i + 1].first, ans[i + 1].second, v[i + 1]);
//        } else if ((v[i + 1] - r2[i]) * (v[i + 1] - r2[i]) <= d + eps && d <= (v[i + 1] + r2[i]) * (v[i + 1] + r2[i]) + eps) {
////            cout << i + 1 << ": out\n";
//            ans[i] = intersect(r2[i], ans[i + 1].first, ans[i + 1].second, v[i + 1]);
//        } else {
////            cout << i + 1 << ": bad\n";
////            ans[i] = ans[i + 1];
////            ans[i].first += v[i + 1];
//            ld dd = dist(ans[i + 1].first, ans[i + 1].second) - v[i + 1];
//            ans[i] = {normalize(ans[i + 1].first, ans[i + 1].second).first * dd,
//                      normalize(ans[i + 1].first, ans[i + 1].second).second * dd};
//        }
    }

//    cout << dist(ans[0].first, ans[0].second) << "\n";
//    for (int i = 0; i + 1 < n; i++) {
//        cout << dist(ans[i].first - ans[i + 1].first, ans[i].second - ans[i + 1].second) << "\n";
//    }

    cout << "Possible\n";
    for (auto [x, y] : ans) {
        cout << x0 + x << " " << y0 + y << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(9) << fixed;

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}