#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;
template<typename T>
using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> cnt(100001), e(100001);
    vector<map<int, int>> col(n + 1);

    ll res = 0;
    auto add = [&](int v, int c) {
        if (cnt[c] == 0) res -= e[c];

        if (col[v][c] <= 1) cnt[c]++;
        col[v][c]++;
        e[c]++;
        if (col[v][c] <= 1) cnt[c]--;

        if (cnt[c] == 0) res += e[c];
    };

    auto del = [&](int v, int c) {
        if (cnt[c] == 0) res -= e[c];

        if (col[v][c] <= 1) cnt[c]++;
        col[v][c]--;
        e[c]--;
        if (col[v][c] <= 1) cnt[c]--;

        if (cnt[c] == 0) res += e[c];
    };

    for (int i = 0; i < q; i++) {
        char t;
        int u, v, c;
        cin >> t >> u >> v >> c;
        if (t == '+') add(v, c), add(u, c);
        if (t == '-') del(v, c), del(u, c);

        cout << res / 2 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}