#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi2,fma")

//#define int long long
#define double long double

long long inf = (long long) (1ll * 1000 * 1000 * 1000 * 1000 * 1000 * 1000 + 10);

struct otr {
    double l, r;
};

struct line{
    double k, b;
};

vector<otr> diap;
vector<line> cht;

double get(double x) {
    int l = 0;
    int r = (int)cht.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (diap[m].l <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return cht[l].k * x + cht[l].b;
}

void update(double k, double b) {
    while (true) {
        if ((int)diap.size() == 0) {
            diap.push_back({-(double)inf, (double)inf});
            cht.push_back({k, b});
            break;
        }
        double k1, b1;
        k1 = cht.back().k;
        b1 = cht.back().b;
        double x_per = (b1 - b) / (k - k1);
        if (x_per > diap.back().l) {
            diap.back().r = x_per;
            diap.push_back({x_per, (double)inf});
            cht.push_back({k, b});
            break;
        } else {
            diap.pop_back();
            cht.pop_back();
        }
    }
}

void solve()
{
    int n, m;
    double c;
    cin >> n >> m >> c;
    vector<double> x(n + 2);
    vector<double> t(n + 2);
    for (int i = 0; i < n; i++) {
        cin >> x[i + 1] >> t[i + 1];
    }
    x[0] = 0;
    x[n + 1] = m;
    t[0] = 0;
    t[n + 1] = 0;
    diap.resize(1, {-(double)inf, (double)inf});
    vector<double> dp(n + 2);
    dp[0] = 0;
    cht.resize(1);
    cht[0] = {0, 0};
    for (int i = 1; i <= n + 1; i++) {
        dp[i] = get(x[i]) + x[i] * x[i] / c + t[i];
        update(-2 * x[i] / c, (dp[i] + x[i] * x[i] / c));
    }
    cout.precision(30);
    cout << dp[n + 1] << "\n";
}

signed main()
{
#ifdef Lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    //cin >> _;
    while (_--)
    {
        solve();
    }
}
